*** vls-trunk-UNMOD/src/mpeg/tsmux.cpp	2004-08-16 17:52:05.000000000 +0200
--- vls-trunk/src/mpeg/tsmux.cpp	2004-09-06 08:49:31.332930616 +0200
***************
*** 57,66 ****
--- 57,69 ----
  #include "tsdemux.h"
  #include "dvbpsi.h"
  
  #include "tsmux.h"
  
+ #ifdef SMARTTV_CA
+ #   include "vls_cas.cpp"
+ #endif
  
  //******************************************************************************
  // C_TsMuxPmtDecoder class
  //******************************************************************************
  //
***************
*** 71,80 ****
--- 74,86 ----
  //------------------------------------------------------------------------------
  C_TsMuxPmtDecoder::C_TsMuxPmtDecoder(C_NetList *pTsProvider,
                                       C_TsMux *pMux,
                                       u16 iProgramNumber) :
                          C_DvbPsiPmtDecoder(iProgramNumber, pTsProvider, this)
+ #ifdef SMARTTV_CA
+   , m_iECMPid(-1)
+ #endif
  {
    ASSERT(pMux);
    uiPnr = iProgramNumber;
    m_pMux = pMux;
  }
***************
*** 107,116 ****
--- 113,125 ----
        m_pMux->m_pDemux->UnselectPid(m_pMux, pEs->i_pid);
        printf("--- %x\n", pEs->i_pid);
        pEs = pEs->p_next;
      }
    }
+ #ifdef SMARTTV_CA
+   startECM(-1);
+ #endif
  
    m_pMux->m_pDemux->UnLock();
  }
  
  
***************
*** 148,162 ****
      pLLPmt = DiffPmtAdd.GetLowLevelPmt();
      dvbpsi_pmt_es_t* pEs = pLLPmt->p_first_es;
      while(pEs)
      {
        m_pMux->m_pDemux->SelectPid(m_pMux, pEs->i_pid, pEs->i_type);
!       printf("+++ %x\n", pEs->i_pid);
        pEs = pEs->p_next;
      }
      m_pMux->m_pDemux->SelectPid(m_pMux, pLLPmt->i_pcr_pid, TS_TYPE_NULL);
  
    }
  }
  
  
  //******************************************************************************
--- 157,174 ----
      pLLPmt = DiffPmtAdd.GetLowLevelPmt();
      dvbpsi_pmt_es_t* pEs = pLLPmt->p_first_es;
      while(pEs)
      {
        m_pMux->m_pDemux->SelectPid(m_pMux, pEs->i_pid, pEs->i_type);
!       // printf("+++ %x\n", pEs->i_pid);
        pEs = pEs->p_next;
      }
      m_pMux->m_pDemux->SelectPid(m_pMux, pLLPmt->i_pcr_pid, TS_TYPE_NULL);
  
+ #ifdef SMARTTV_CA
+     startECM(casPmtEcmPid());
+ #endif
    }
  }
  
  
  //******************************************************************************
***************
*** 168,177 ****
--- 180,192 ----
  //------------------------------------------------------------------------------
  // Constructor
  //------------------------------------------------------------------------------
  C_TsMux::C_TsMux(C_NetList *pTsProvider, C_TsDemux *pDemux,
                   I_TsPacketHandler *pHandler) : m_cPat(1, 0, true)
+ #ifdef SMARTTV_CA
+   ,m_cCat(this, pTsProvider, pDemux, pHandler)
+ #endif 
  {
    ASSERT(pTsProvider);
    ASSERT(pDemux);
    ASSERT(pHandler);
  
***************
*** 194,206 ****
  // Mux initialilzation
  //------------------------------------------------------------------------------
  void C_TsMux::Attach()
  {
    // Lock the demux because we're running in another thread
    m_pDemux->Lock();
! 
    m_pDemux->SelectPid(this, 0x0000, TS_TYPE_NULL);
  
    m_pDemux->UnLock();
  }
  
  
--- 209,226 ----
  // Mux initialilzation
  //------------------------------------------------------------------------------
  void C_TsMux::Attach()
  {
    // Lock the demux because we're running in another thread
+ fprintf(stderr, "mux ....%d\n", 0);
    m_pDemux->Lock();
! fprintf(stderr, "mux ....%d\n", 1);
    m_pDemux->SelectPid(this, 0x0000, TS_TYPE_NULL);
+ fprintf(stderr, "mux ....%d\n", 2);
+ #ifdef SMARTTV_CA
+   m_cCat.Attach();
+ #endif
  
    m_pDemux->UnLock();
  }
  
  
***************
*** 226,236 ****
  
      cIterator.Reset();
    }
  
    m_pDemux->UnselectPid(this, 0x0000);
! 
    m_pDemux->UnLock();
  }
  
  
  //------------------------------------------------------------------------------
--- 246,258 ----
  
      cIterator.Reset();
    }
  
    m_pDemux->UnselectPid(this, 0x0000);
! #ifdef SMARTTV_CA
!    m_cCat.Detach();
!  #endif
    m_pDemux->UnLock();
  }
  
  
  //------------------------------------------------------------------------------
***************
*** 378,387 ****
--- 400,413 ----
  
        // Here we are, this PMT refers to the right streams. But we can't send
        // it: we need to regenerate the continuity counter... Let's generate
        // all the PMT packets ...
  
+       if (!pDecoder->GetCurrentPmt()) {
+         fprintf(stderr,"PMT abort\n");
+         return true;
+       }
        pDecoder->GetCurrentPmt()->Generate();
        pDecoder->GetCurrentPmt()->TsReset();
        while(pDecoder->GetCurrentPmt()->TsHasNext())
        {
  
